//==============================================
//  copyright            : (C) 2003 by Will Stokes
//==============================================
//  This program is free software; you can redistribute it 
//  and/or modify it under the terms of the GNU General 
//  Public License as published by the Free Software 
//  Foundation; either version 2 of the License, or  
//  (at your option) any later version.         
//
//  As a special exception, Will Stokes gives permission to 
//  link this program with Qt non-commercial edition, and 
//  distribute the resulting executable, without including the 
//  source code for the Qt non-commercial edition in the 
//  source distribution. 
//==============================================

#ifndef GUI_PHOTOWIDGET_H
#define GUI_PHOTOWIDGET_H

//--------------------
//forward declarations
class QPixmap;
class QString;
class Photo;
class PhotosIconView;
//--------------------

#include <qiconview.h>

//=====================================
/*! \brief Displays photo thumbnail and description.
 */
//=====================================
class PhotoWidget : public QIconViewItem
{
public:
  ///Sets subalbum pointer
  PhotoWidget( PhotosIconView *parent,
               Photo* phto );
               
  ///Returns photo pointer
  Photo* getPhoto();
  
  ///Syncs photo's description
  void sync();

  ///Update photo thumbnail from background object  
  void updateImage();

  ///Update photo description  
  void updateDescription();
  
  ///Repain iconview item
  void paintItem( QPainter* p, 
                  const QColorGroup& cg);
                  
  void setText ( const QString & text );
  
  bool acceptDrop( const QMimeSource *e) const;
  
  int compare ( QIconViewItem * i ) const;
//----------------------
private:
  void dropped( QDropEvent *e, const QValueList<QIconDragItem> &lst );
  
  ///Pointer to photo backend object
  Photo* phto;

  ///Parent
  PhotosIconView* parent;
//----------------------
};
//======================

#endif //GUI_PHOTOWIDGET_H
