//==============================================
//  copyright            : (C) 2003 by Will Stokes
//==============================================
//  This program is free software; you can redistribute it 
//  and/or modify it under the terms of the GNU General 
//  Public License as published by the Free Software 
//  Foundation; either version 2 of the License, or  
//  (at your option) any later version.         
//
//  As a special exception, Will Stokes gives permission to 
//  link this program with Qt non-commercial edition, and 
//  distribute the resulting executable, without including the 
//  source code for the Qt non-commercial edition in the 
//  source distribution. 
//==============================================

#ifndef GUI_SUBALBUMPREVIEWWIDGET_H
#define GUI_SUBALBUMPREVIEWWIDGET_H

//--------------------
//forward declarations
class Subalbum;
class QPixmap;
class QString;
class SubalbumsIconView;
//--------------------

#include <qiconview.h>
#include <qobject.h>

//=====================================
/*! \brief Displays subalbum icon and name.
 */
//=====================================
class SubalbumPreviewWidget : public QIconViewItem
{
public:
  ///Sets subalbum pointer
  SubalbumPreviewWidget( SubalbumsIconView* parent,
                         Subalbum* salbum );
                         
  ///Returns subalbum pointer
  Subalbum* getSubalbum();
  
  void paintItem( QPainter* p, 
                  const QColorGroup& cg);
  bool acceptDrop( const QMimeSource *e) const;
  
  int compare ( QIconViewItem * i ) const;
  
//----------------------
private:
  void dropped( QDropEvent *e, const QValueList<QIconDragItem> &lst );
  
  ///Pointer to subalbum backend object
  Subalbum* subalbum;

  ///Representative Image for Subalbum
  QPixmap* subalbumPreviewImage;

  ///Subalbum's Name
  QString* subalbumName;
  
  ///parent icon view
  SubalbumsIconView* parent;
//----------------------
};
//======================

#endif //GUI_SUBALBUMPREVIEWWIDGET_H
