//==============================================
//  copyright            : (C) 2003 by Will Stokes
//==============================================
//  This program is free software; you can redistribute it 
//  and/or modify it under the terms of the GNU General 
//  Public License as published by the Free Software 
//  Foundation; either version 2 of the License, or  
//  (at your option) any later version.         
//
//  As a special exception, Will Stokes gives permission to 
//  link this program with Qt non-commercial edition, and 
//  distribute the resulting executable, without including the 
//  source code for the Qt non-commercial edition in the 
//  source distribution. 
//==============================================

//Systemwide includes
#include <qpixmap.h>
#include <qpainter.h>

//Projectwide includes
#include "subalbumsIconView.h"

#include <iostream.h>

//==============================================
SubalbumsIconView::SubalbumsIconView( QWidget *parent ) : QIconView( parent )
{
}
//==============================================
void SubalbumsIconView::contentsDropEvent( QDropEvent *e )
{
  QIconView::contentsDropEvent( e );

  //get iconviewitem that was dropped  
  QIconViewItem *item = findItem( e->pos() );
  
  //if item exists and drop item was originally in this viewport then
  //user has dragged item within iconview, emit item has moved signal
  if( item != NULL && e->source() == viewport())
    emit itemHasMoved();
}
//==============================================
 void SubalbumsIconView::drawContents ( QPainter * p, int clipx, int clipy, int clipw, int cliph )
{
    if( bufferPixmap.size() != size())
    {  bufferPixmap.resize( size() ); }
    QPainter bufferPainter( &bufferPixmap, viewport() );
    int xOffset = clipx - contentsX();
    int yOffset = clipy - contentsY();

    bufferPainter.translate( -contentsX(), -contentsY() );
    QIconView::drawContents( &bufferPainter, clipx, clipy, clipw, cliph );
    bitBlt(p->device(), xOffset, yOffset, &bufferPixmap, xOffset, yOffset, clipw, cliph );
}
//==============================================
